// CavePointer
#include <sys/time.h>
//#include <pfcave.h>
#include <cave.h>

#include "CavePointer.hh"

//CavePointer::CavePointer(CavePointerType ptr):ptrType(ptr),device(ptr){}
CavePointer::CavePointer(CAVEID ptr):device(ptr){}

// subclass CaveSensor
void CavePointer::orientation(float v[3]){
	CAVEGetOrientation(device,v);
}

void CavePointer::position(float v[3]){
	CAVEGetPosition(device,v);
}

void CavePointer::worldPosition(float v[3]){
  float vp[3];
  CAVEGetPosition(device,vp);
  CAVENavConvertCAVEToWorld(vp,v);
}

void CavePointer::unitVectorDirection(float v[3]){
	//if(ptrType==wand) 
	if(device==CAVE_WAND) 
		CAVEGetVector(CAVE_WAND_FRONT,v);
	else
		CAVEGetVector(device,v);
}

void CavePointer::orientation(pfVec3 &v){
  float vp[3];
  orientation(vp);
  v[0]=vp[0];
  v[1]=vp[1];
  v[2]=vp[2];
}

void CavePointer::position(pfVec3 &v){
  float vp[3];
  position(vp);
  v[0]=vp[0];
  v[1]=vp[1];
  v[2]=vp[2];
}

void CavePointer::worldPosition(pfVec3 &v){
  float vp[3];
  worldPosition(vp);
  v[0]=vp[0];
  v[1]=vp[1];
  v[2]=vp[2];
}

void CavePointer::unitVectorDirection(pfVec3 &v){
  float vp[3];
  unitVectorDirection(vp);
  v[0]=vp[0];
  v[1]=vp[1];
  v[2]=vp[2];
}
/*
CaveIntValuator::CaveIntValuator(CAVE_DEVICE_ID dev):device(dev){
}
long CaveIntValuator::getValue(){return CAVEgetvaluator(dev);}
*/

CavePointer CaveWand(CAVE_WAND);
CavePointer CaveHead(CAVE_HEAD);
